unit usignet;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, ugraftool;

type
  //Matrix = ARRAY[1..14] OF TPOINT; in der Unit DPGraftool deklariert

  Tfsignet = class(TForm)
    BitBtn1: TBitBtn;
    bzeichnen: TButton;
    efaktor: TEdit;
    ewinkel: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    ezeit: TEdit;
    Label3: TLabel;
    procedure bzeichnenClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  fsignet: Tfsignet;
  Signet : Matrix;

implementation

{$R *.dfm}

procedure Tfsignet.bzeichnenClick(Sender: TObject);
VAR z,w,u : INTEGER;
    r : REAL;

PROCEDURE Line(x1,y1,x2,y2 : INTEGER);
 BEGIN
  Canvas.MoveTo(x1,y1);
  Canvas.LineTo(x2,y2);
 END;

PROCEDURE Zeichne_Signet(Figur: Matrix);
VAR i : INTEGER;
BEGIN
  //canvas.Pen.Color:=clblack;
{Begrenzungspolygon}
  canvas.polygon(Slice(Figur,8));

{Bildschirm}
  Line(Figur[10].X, Figur[10].Y, Figur[11].X, Figur[11].Y);
  Line(Figur[11].X, Figur[11].Y, Figur[12].X, Figur[12].Y);
  Line(Figur[12].X, Figur[12].Y, Figur[13].X, Figur[13].Y);
  Line(Figur[13].X, Figur[13].Y, Figur[10].X, Figur[10].Y);

  Line(Figur[14].X, Figur[14].Y, Figur[15].X, Figur[15].Y);
  Line(Figur[15].X, Figur[15].Y, Figur[16].X, Figur[16].Y);
  Line(Figur[16].X, Figur[16].Y, Figur[17].X, Figur[17].Y);
  Line(Figur[17].X, Figur[17].Y, Figur[14].X, Figur[14].Y);

  {Canvas.Brush.Style:=bssolid;
  Canvas.Brush.Color:=clblue;
  Canvas.FloodFill(Figur[18].X,Figur[18].Y,clblack,fsborder);
  // fsborder = Fllt den Bereich bis zum rand mit der Farbe clblack}
  Canvas.Brush.Style:=bsclear; //sonst alles blau

{Computergehuse}
  Line(Figur[19].X, Figur[19].Y, Figur[20].X, Figur[20].Y);
  Line(Figur[20].X, Figur[20].Y, Figur[21].X, Figur[21].Y);
  Line(Figur[21].X, Figur[21].Y, Figur[22].X, Figur[22].Y);
  Line(Figur[22].X, Figur[22].Y, Figur[19].X, Figur[19].Y);
{Schlitze}
  Line(Figur[23].X, Figur[23].Y, Figur[24].X, Figur[24].Y);
  Line(Figur[25].X, Figur[25].Y, Figur[26].X, Figur[26].Y);
{Schrift}
  canvas.MoveTo(Figur[27].X,Figur[27].Y);
  FOR I:=28 TO 31 DO canvas.LineTo(Figur[I].X,Figur[I].Y);

  canvas.MoveTo(Figur[32].X,Figur[32].Y);
  FOR I:=33 TO 37 DO canvas.LineTo(Figur[I].X,Figur[I].Y);

  canvas.MoveTo(Figur[38].X,Figur[38].Y);
  FOR I:=39 TO 42 DO canvas.LineTo(Figur[I].X,Figur[I].Y);

  canvas.MoveTo(Figur[43].X,Figur[43].Y);
  FOR I:=44 TO 48 DO canvas.LineTo(Figur[I].X,Figur[I].Y);

  canvas.MOVETO(Figur[49].X,Figur[49].Y);

  I:=50; canvas.LineTo(Figur[I].X,Figur[I].Y);

  canvas.MoveTo(Figur[51].X,Figur[51].Y);
  FOR I:=52 TO 56 DO canvas.LineTo(Figur[I].X,Figur[I].Y);

  canvas.MOVETO(Figur[57].X,Figur[57].Y);
  FOR I:=58 TO 61 DO canvas.LineTo(Figur[I].X,Figur[I].Y);

  canvas.MoveTo(Figur[62].X,Figur[62].Y);
  FOR I:=63 TO 67 DO canvas.LineTo(Figur[I].X,Figur[I].Y);

  canvas.MOVETO(Figur[68].X,Figur[68].Y);
  FOR I:=69 TO 71 DO canvas.LineTo(Figur[I].X,Figur[I].Y);

END;

begin
 SetViewPortOrgEx(Canvas.Handle, fsignet.width DIV 2, fsignet.height DIV 2,nil);
 //Eingaben
 r:=STRTOFLOAT(efaktor.Text);
 w:=STRTOINT(ewinkel.Text);
 u:=STRTOINT(ezeit.Text);
 //Verarbeitung
 FOR z:=1 TO TRUNC(360/w) DO
   BEGIN
    Signet_Daten(Signet);
    Verzerren(r,r,71,Signet);
    //Verschieben(r,0,71,Signet);
    Drehen(0,0,Z*W,Signet,71);
    canvas.Pen.color:=clblack;
    Zeichne_Signet(Signet);
    SLEEP(u);
    canvas.Pen.color:=clbtnface;
    Zeichne_Signet(Signet);
   END;
end;

procedure Tfsignet.Button1Click(Sender: TObject);
begin
 REFRESH;
end;

end.
